#include <SDL.h>
#include <SDL_image.h>

#include <string>
#include <iostream>

using namespace std;

#include "scoreboard.h"
#include "rendermanager.h"

void ScoreBoard::init()
{
	Image::init();

	width=(int)(img->w/10);
	num=s->getNum();
	rect.w=width*2+SEPARATION;
	rect.h=img->h;
}

void ScoreBoard::update()
{
	Image::update();
	if(num!=s->getNum())
	{
		g->rendermanager->addToDraw(rect);
		num=s->getNum();
	}
}

void ScoreBoard::draw()
{
	//Los rectangulos uno para el destino en la pantalla y otro
	//para coger el numero dentro de la grilla
	SDL_Rect dst=owner->getRect();
	SDL_Rect n;

	if(s->getNum()>99)
		return;
	//Rellenamos num para las decenas
	int dec=(int)(s->getNum()/10);
	n.x=dec*width;
	n.y=0;
	n.w=width;
	n.h=img->h;

	//Pegamos la imagen
	SDL_BlitSurface(img,&n,SDL_GetVideoSurface(),&dst);

	//Ponemos la unidades a la derecha
	dst.x+=width+SEPARATION;

	//Rellenamos num para las unidades
	n.x=(s->getNum()-(dec*10))*width;

	//Pegamos la imagen
	SDL_BlitSurface(img,&n,SDL_GetVideoSurface(),&dst);
}

