#include <SDL.h>
#include <SDL_rotozoom.h>

#include <string>

using namespace std;

#include "specialimage.h"
#include "utils.h"
#include "rendermanager.h"
#include "actor.h"

void SpecialImage::init()
{
	img=LoadImgAlpha(name);
	orig=LoadImgAlpha(name);
	center=owner->getCenter();
}

void SpecialImage::activate()
{
	rect=owner->getGraphicRect();
	g->rendermanager->addToDraw(rect);
}

void SpecialImage::update()
{
	if(center!=owner->getCenter())
	{
		//Poner el fondo donde estaba antes
		g->rendermanager->addToDraw(rect);

		center=owner->getCenter();
		rect=owner->getGraphicRect();
		change=false;

		//Poner el fondo donde va a estar ahora
		g->rendermanager->addToDraw(rect);
	}
}

void SpecialImage::rotateRight()
{
	SDL_FreeSurface(img);
	img=rotozoomSurface(orig,270,1,SMOOTHING_ON);
	g->rendermanager->addToDraw(rect);
}

void SpecialImage::rotateLeft()
{
	SDL_FreeSurface(img);
	img=rotozoomSurface(orig,90,1,SMOOTHING_ON);
	g->rendermanager->addToDraw(rect);
}

void SpecialImage::rotate(float ang)
{
	SDL_FreeSurface(img);
	img=rotozoomSurface(orig,ang,1,SMOOTHING_ON);
	g->rendermanager->addToDraw(rect);
}
