#ifndef TEXTIMAGE_H
#define TEXTIMAGE_H

#include "fontmanager.h"
#include "text.h"

class TextImage : public ActorGraphic
{
	public:
		TextImage(Actor *a,Text *t,const string nf,const unsigned s);
		~TextImage(){SDL_FreeSurface(img);}

		void init();
		void activate();
		void update();
		void desactivate();
		
		typedef enum
		{
			LEFT,
			CENTER,
			RIGHT,
		}alignment_t;

		typedef enum
		{
			SOLID,
			SHADED,
			BLENDED
		}style_t;

		style_t getStyle()const{return style;}
		void setStyle(const style_t t){style=t;change=true;}

		void setAlignment(const alignment_t a){alignment=a;change=true;}

		void setBackground(const SDL_Color &c){background=c;change=true;}
		void setFontColor(const SDL_Color &c){fontcolor=c;change=true;}
		void setSize(const unsigned s);

		void updateIMG();
		void updatePOS();

		void draw();
		unsigned get_w()const{return img->w;}
		unsigned get_h()const{return img->h;}

	protected:
		SDL_Surface *img;
		Text *text;

		FontManager::font_id font;
		string namefont;
		unsigned size;
		style_t style;

		alignment_t alignment;

		SDL_Color fontcolor;
		SDL_Color background;
		bool change;
};

#endif
